/*
 * Author: Heinz Mauelshagen, Germany (mge@ez-darmstadt.telekom.de)
 *
 * June 1998
 *
 * LVM is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * LVM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with GNU CC; see the file COPYING.  If not, write to
 * the Free Software Foundation, 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA. 
 *
 */

#include <liblvm.h>

int vg_free ( vg_t *vg, int all) {
   int l = 0;
   int p = 0;

   if ( vg == NULL || ( all != TRUE && all != FALSE)) return -LVM_EPARAM;

   for ( p = 0; p < vg->pv_max; p++) {
      if ( vg->pv[p] != NULL) {
         if ( vg->pv[p]->pe != NULL)
            free ( vg->pv[p]->pe);
         free ( vg->pv[p]);
         vg->pv[p] = NULL;
      }
   }

   for ( l = 0; l < vg->lv_max; l++) {
      if ( vg->lv[l] != NULL) {
         if ( vg->lv[l]->lv_current_pe != NULL)
            free ( vg->lv[l]->lv_current_pe);
         free ( vg->lv[l]);
         vg->lv[l] = NULL;
      }
   }

   if ( all == TRUE) free ( vg);

   return 0;
}
